#!/bin/sh
 # -*- mode: tcl; tab-width: 4; coding: iso-8859-1 -*-
 # Restart with tcl:  \
 # exec wish $0 ${1+"$@"}

 # neuro1.tcl - HaJo Gurt - 2006-10-17 - http://wiki.tcl.tk/17067
 #: Widgets on a canvas : Sliders + Entryfields
 # Simple Schema of a neuron, summing its input-signals,
 # and firing when the sum exceeds a threshold.

#! /bin/env Tclsh
# package require Tk
# pack [button .b -text {Push Me} -command {
#    tk_messageBox -message {hello, world}
# }]



  package require Tk
  

  array set S { x1 20  w1 1   x2 50  w2  8 \
                t1 500 title "Neuronal Processing" \
                s1 0   s2 0  sum 0  out 0 }

  proc int x { expr int($x) }

  proc Calc x {
  #: Calculate results + update display
    global S

    set S(s1)  [expr {$S(x1) * $S(w1)} ]
    set S(s2)  [expr {$S(x2) * $S(w2)} ]
    set S(sum) [expr {$S(s1) + $S(s2)} ]
    set S(out) [expr {$S(sum) >= $S(t1)} ]
    if { $S(out) } {
      .ca itemconfig out -fill red 
	  pdsend "sumout 1" 
    } else {
      .ca itemconfig out -fill cyan
    }
  }
	 
	  
  proc Init {} {
  #: Build GUI
    global S

    wm title . "MyText"
    canvas .ca -relief raised  -borderwidth 0  -height 400  -width 560  -bg white
    pack   .ca

    option add *Scale.highlightThickness 0
    option add *Scale.orient vertical
    option add *Scale.relief ridge
    option add *Entry.relief sunken

    scale .ca.sx1 -from 100 -to    0 -variable S(x1) -command Calc -label "x1"  
    scale .ca.sx2 -from 100 -to    0 -variable S(x2) -command Calc -label "x2"  
    scale .ca.sw1 -from  10 -to    0 -variable S(w1) -command Calc -label "w1"  
    scale .ca.sw2 -from  10 -to    0 -variable S(w2) -command Calc -label "w2"  
    scale .ca.st1 -from   0 -to 2000 -variable S(t1) -command Calc -label "Threshold" -orient horizontal 

    entry .ca.es1 -width 5 -textvar S(s1)  -state readonly
    entry .ca.es2 -width 5 -textvar S(s2)  -state readonly
   #entry .ca.es3 -width 5 -textvar S(sum) -state readonly  ;##
    scale .ca.ss3 -from 2000 -to   0 -variable S(sum) -length 200 -sliderlength 5 -state disabled -bg green2
    entry .ca.es4 -width 3 -textvar S(out) -state readonly

    .ca create text   280  20          -text $S(title) -font {Times 24 bold}

    .ca create text    12  80          -text "Input 1"   -anchor w
    .ca create line    30 100  310 100 -width 5 -arrow last
    .ca create window  50  50          -window .ca.sx1    -anchor nw
    .ca create window  50 200          -window .ca.sx2    -anchor nw
    .ca create window 240  75          -window .ca.es1    -anchor w

    .ca create text    12 230          -text "Input 2"   -anchor w
    .ca create line    30 250  310 250 -width 5 -arrow last
    .ca create window 150  50          -window .ca.sw1    -anchor nw
    .ca create window 150 200          -window .ca.sw2    -anchor nw
    .ca create window 240 225          -window .ca.es2    -anchor w

    .ca create text   160 315          -text "Weight"    -anchor w

    .ca create window 275 320          -window .ca.st1    -anchor nw
    .ca create line   350 320  350 300 -width 1 -arrow last

    .ca create oval   300  50  400 300 -width 3 -fill green2
    .ca create text   350  65          -text "Sum"
    .ca create window 350 175          -window .ca.ss3  ;## .ca.es3 / .ca.ss3
    .ca create line   400 175  450 175 -width 5 -arrow last

    .ca create oval   450 125  530 225 -width 3 -tag out
    .ca create text   490 150          -text "Output"
    .ca create window 490 175          -window .ca.es4

    # Debug: show cursor-position :
#   bind .ca <Motion>  {wm title . [int [%W canvasx %x]],[int [%W canvasy %y]]}
  }
  
  

  Init
